
#include <qpainter.h>
#include <qcolor.h>
#include <qpen.h>
#include <qcolor.h>
#include <qsizepolicy.h>
#include <qsize.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>

#include "paint_widget.h"


//Konstruktor, bekommt parent, size des Arrays, maximum und Pointer auf
// das zu sortierende Array (von dem keine Kopie angelegt wird)
PaintWidget::PaintWidget(QWidget *qw,int s,double max,double *p)
    :QWidget(qw),array_size(s),maximum(max),arr(p)
{
  setBackgroundColor(white);
}


void PaintWidget::repaintWidget()
{
  /*QPainter *d=paint_rect(10,10);
  d->setPen(QPen(black,2,QPen::SolidLine));
  d->drawLine(10,height()-10,10,10);
  delete d;*/
}



//Standardroutine wird beim erstellen aufgerufen, also init-Anzeige
void PaintWidget::paintEvent(QPaintEvent *)
{
  //QPainter *d=paint_rect_fill(10,10,1);
  //delete d;
}

//---- fr nnresult

void PaintWidget::paint_Balken()
{
  //QPainter *d=paint_rect_fill(10,10,1);
  //delete p;

    double a=0.2;
    double e=0.3;
    double i=0.1;
    double o=0.7;
    double u=0.5;
    if (array_size==1)
      {
	paint5WerteBalken(a,e,i,o,u);
      }
    else if (array_size==2)
      {
	paint3WerteBalken(1.0,0.5,0.25);
      }
    else if (array_size==3)
      {
	paint3WerteBalken(0.3,0.3,0.3);
      }
    else if (array_size==4)
      {
	paint3WerteBalken(0.1,0.3,0.25);
      }

}

void PaintWidget::paint5WerteBalken(double a, double e, double i, double o, double u)
{
  //300x120
  QPainter *p=new QPainter(this);
  p->fillRect(0,0,300,120,QBrush(QColor(255, 255, 255)));

  p->fillRect(  5,5,50,(int)(a*100.0),QBrush(QColor(  0,  0,255)));
  p->fillRect( 65,5,50,(int)(e*100.0),QBrush(QColor(  0,255,  0)));
  p->fillRect(125,5,50,(int)(i*100.0),QBrush(QColor(255,  0,  0)));
  p->fillRect(185,5,50,(int)(o*100.0),QBrush(QColor(255,  0,255)));
  p->fillRect(245,5,50,(int)(u*100.0),QBrush(QColor(0,  255,255)));

  delete p;
}

void PaintWidget::paint3WerteBalken(double a, double e, double i)
{
  //160x110
  QPainter *p=new QPainter(this);
  p->fillRect(0,0,160,110,QBrush(QColor(255, 255, 255)));

  p->fillRect(2,5,50,(int)(a*100.0),QBrush(QColor(0,0,255)));
  p->fillRect(55,5,50,(int)(e*100.0),QBrush(QColor(0,255,0)));
  p->fillRect(108,5,50,(int)(i*100.0),QBrush(QColor(255,0,0)));

  delete p;
}




//---- fr Gewichtsmatrix

void PaintWidget::paint_Matrizen(int *matrixA, int **matrix, int sizeX, int sizeY)
{
  //QPainter *d=paint_rect_fill(10,10,1);

  //init-Bild
  QPainter *p=new QPainter(this);
  /*if(array_size==2) //310x300=Malflche
    {
      for (int j=0; j<31;j++)
	{
	  for (int i=0; i<30;i++)
	    {
	      p->fillRect(j*10,i*10,10,10,QBrush(QColor(10+j*8,10+i*8,0)));
	    }
	}
    }
  if(array_size==1) //300x30
    {
      for (int i=0; i<10;i++)
	{
	  p->fillRect(0,i*30,30,30,QBrush(QColor(0,10+i*25,0)));
	}
    }*/

  paintVMatrix(matrixA,10 );
  paint2DMatrix(matrix, sizeX, sizeY);


  delete p;
}

//Schwellwertmatrix zeichnen
//length Werte!!! Eintrge 0-255!!!
void PaintWidget::paintVMatrix(int matrix[], int length)
{
  QPainter *p=new QPainter(this);
  int high=0;

  high=(int)(300/length);//Hhe eines Rects= Gesamthhe/Anzahl der Rects

  //300x30
  for (int i=0; i<length;i++)
    {
      p->fillRect(0,i*high,30,high,QBrush(QColor(0,0,matrix[i])));
    }

  delete p;
}

//maximale Matrixgre 31x30
//Werte von 0-255!!!
void PaintWidget::paint2DMatrix(int **matrix, int sizeX, int sizeY)
{

  QPainter *p=new QPainter(this);
  //Background
  p->fillRect(0,0,310,300,QBrush(QColor(0,0,0)));

  int Xsize=0;
  int Ysize=0;
  Xsize = (int)(300/sizeX);
  Ysize = (int)(300/sizeY);


  //310x300=Malflche
  for (int j=0; j<sizeX;j++)
    {
      for (int i=0; i<sizeY;i++)
	{
	  //p->fillRect(j*10,i*10,10,10,QBrush(QColor(0,matrix[j][i],0)));
	  p->fillRect(j*Xsize,i*Ysize,Xsize,Ysize,QBrush(QColor(0,matrix[j][i],0)));
	}
    }

  delete p;
}



//---- fr Fehlerkurve

void PaintWidget::paint_1DArray(double *Trainingswerte, double *Testwerte, int laenge, double skalierung)
{
  QPainter *d=paint1DArray(Trainingswerte, Testwerte, laenge, skalierung);
  //QPainter *d=paint_1DArray(a,b,500);
  //QPainter *d=paint_1DArray(Trainingswerte, Testwerte, laenge);
  delete d;
}

//zeichnet alle Werte eines 1D Arrays entlang der x-Achse
//unser Widget ist 531x250 gro und es soll unten anfangen zu zeichnen unten=0-Achse
QPainter* PaintWidget::paint1DArray(double *a, double *b, int length, double scaling)
{
  QPainter *p=new QPainter(this);
  p->fillRect(0,0,531,250,QBrush(QColor(255,255,255)));
  
int t=(int)(length/531)+1;
int k=0;

  if(length>531)
    {
      for (int i=0; i<length; i+=t)
	{
	  p->fillRect(k, 250-(int)(a[i]*scaling) ,1,1,QBrush(QColor(255,0,0)));
	  p->fillRect(k, 250-(int)(b[i]*scaling) ,1,1,QBrush(QColor(0,0,255)));
	  k++;
	}
    }else{
      for (int i=0; i<length; i++)
	{
	  p->fillRect(i, 250-(int)(a[i]*scaling) ,1,1,QBrush(QColor(255,0,0)));
	  p->fillRect(i, 250-(int)(b[i]*scaling) ,1,1,QBrush(QColor(0,0,255)));
	}
    }
  return p;
}


// ------------------------------ nicht direkt fr ProjectNN --------------------

//meine Rechteckmalfunktion...
QPainter* PaintWidget::paint_rect(int x, int y)
{
  QPainter *p=new QPainter(this);

  p->setPen(QPen(green,2,QPen::SolidLine));
  p->drawRect(x,y,10,10);

  p->setPen(QPen(red,2,QPen::SolidLine));
  p->drawRect(x+20,y+20,10,10);

return p;

}

//meine Rechteckmalfunktion gefllt
QPainter* PaintWidget::paint_rect_fill(int x, int y, int c)
{
  QPainter *p=new QPainter(this);

  x=x;y=y;c=c;

  //TODO:
  //1.IF Abfrage nach Color
  //2.Entprechend Rechteck an Position x,y zeichnen
  //ein Rechteck wird alle 10x10 Punkte gemalt, hat aber nur Gre 9x9 wegen Rand!

  //Beispielreihe:
  for (int i=0; i<60; i++)
    p->fillRect(i*10,200,9,9,QBrush(QColor(0,0,i*25)));

return p;
}




// gibt das Streckungsverhalten in einem QLayout an
QSizePolicy PaintWidget::sizePolicy() const
{
  return QSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
}

// gibt die ueber QSizePolicy zu interpretierende Breite und Hoehe des
// Widgets an
QSize PaintWidget::sizeHint() const
{
  return QSize(100,100);
}
