#ifndef THESCHICHT   // falls Schicht zweimal inkludiert wird
#define THESCHICHT
 
#include "Neuron.h"

#define TANH 1
#define LOGI 2
#define IDENTITAET 0

class Schicht;

ostream& operator<< (ostream &ostr, const Schicht &);
istream& operator>> (istream &istr, Schicht &); 

class Schicht {
  friend ostream& operator<< (ostream &ostr, const Schicht &);
  friend istream& operator>> (istream &istr, Schicht &);

 protected:
  // Variablen, die in die .NTZ Dateien gespeichert werden
  // (auch in dieser Reihenfolge)
  int inputDim, outputDim;
  Neuron **Neurons;            // Dimension ist outputDim und 1
  int tFTyp;                   // Tranferfunktion Typ
 private:
  // Werden nur fuer Ausgabe benutzt. (Memory-leaks vermeiden)
  // Fuer die jeweiligen Funktionen darf der Benutzer darf sie nicht veraendern.
  double *propagateAusgabe;
  double *getSchwellenAusgabe;
  double **getGewichteAusgabe;

 public:
  Schicht(int, int, int);       // Konstruktor fuer Zufallswerten
  Schicht(int, int, int, bool); // Konstruktor fuer die nullte Schicht
  Schicht(int, int, int, double **, double *); 
  ~Schicht(void);                       // Destruktor fuer *Neurons;

  double *propagate(double *);
  void doDeltas(void);

  double *recentPropagate(void);

  // Getter/Setter
  int getTFTyp(void){ return tFTyp; }
  void setTFTyp(int theTFTyp){ tFTyp = theTFTyp; }
  void updateDeltas(double **, double *);
  double *getSchwellen(void);
  double **getGewichte(void);
  int getInputDim(void){ return inputDim; }
  int getOutputDim(void){ return outputDim; }
};

#endif
